package com.eco.plugin.xx.jbsync.config;

import com.fr.config.*;
import com.fr.config.holder.Conf;
import com.fr.config.holder.factory.Holders;
import com.fr.intelli.record.Focus;
import com.fr.intelli.record.Original;
import com.fr.record.analyzer.EnableMetrics;

@Visualization(category = "数据同步配置")
@EnableMetrics
public class PluginSimpleConfig extends DefaultConfiguration {

    private static volatile PluginSimpleConfig config = null;

    @Focus(id="com.eco.plugin.xx.jbsync.config", text = "数据同步配置", source = Original.PLUGIN)
    public static PluginSimpleConfig getInstance() {
        if (config == null) {
            config = ConfigContext.getConfigInstance(PluginSimpleConfig.class);
        }
        return config;
    }

    @Identifier(value = "secret", name = "密钥", description = "密钥", status = Status.SHOW)
    private Conf<String> secret = Holders.simple("");

    @Identifier(value = "debugSwitch", name = "插件调试开关", description = "日志调试模式", status = Status.SHOW)
    private Conf<Boolean> debugSwitch = Holders.simple(true);

    public String getSecret() {
        return secret.get();
    }

    public void setSecret(String url) {
        this.secret.set(url);
    }

    public Boolean getDebugSwitch() {
        return debugSwitch.get();
    }

    public void setDebugSwitch(Boolean url) {
        this.debugSwitch.set(url);
    }

    @Override
    public Object clone() throws CloneNotSupportedException {
        PluginSimpleConfig cloned = (PluginSimpleConfig) super.clone();
//        cloned.text = (Conf<String>) text.clone();
//        cloned.count = (Conf<Integer>) count.clone();
//        cloned.price = (Conf<Double>) price.clone();
//        cloned.time = (Conf<Long>) time.clone();
//        cloned.student = (Conf<Boolean>) student.clone();
        return cloned;
    }

}
