package com.eco.plugin.wink.jbsync.utils;

import com.fr.decision.webservice.bean.user.DepartmentPostBean;
import com.fr.decision.webservice.v10.user.DepartmentService;

import java.util.List;

public class FRDepartmentUtils {

    public static void main(String[] args) {

    }

    /**
     * 获取用户Service
     * @return
     */
    public static DepartmentService getDepartmentService(){
        return DepartmentService.getInstance();
    }

    /**
     * 添加部门
     * @param pId   父节点id
     * @param dpName 部门名称
     */
    public static DepartmentPostBean addDP(String pId, String dpName) throws Exception {
        if(Utils.isNullStr(pId)){
            pId = "decision-dep-root";
        }
        return getDepartmentService().addDepartment(pId,dpName);
    }

    /**
     * 修改组织
     * @param id
     * @param dpName
     */
    public static void updateDP(String id,String dpName) throws Exception {
        getDepartmentService().editDepartment(id,dpName);
    }

    /**
     *  删除机构
     * @param id
     * @return
     */
    public static void deleteDepartment(String id) throws Exception {
        getDepartmentService().deleteDepartment(id);
    }

    /**
     * 获取所有组织机构
     * @param adminUserid
     * @return
     * @throws Exception
     */
    public static List<DepartmentPostBean> getDepartmentTree(String adminUserid) throws Exception {
        List<DepartmentPostBean> departmentTree = getDepartmentService().getDepartmentTree(adminUserid);
        return departmentTree;
    }

    /**
     * 获取pid下组织机构
     * @param adminUserid
     * @param pid
     * @return
     * @throws Exception
     */
    public static List<DepartmentPostBean> getDepartmentsUnderParentDepartment(String adminUserid,String pid) throws Exception {
        if(pid == null || pid.isEmpty()){
            pid = "decision-dep-root";
        }
        List<DepartmentPostBean> departmentTree = getDepartmentService().getDepartmentsUnderParentDepartment(adminUserid,pid);
        return departmentTree;
    }

    /**
     * 获取pid下对应名字的组织机构
     * @param adminUserid
     * @param departname
     * @param pid
     * @return
     * @throws Exception
     */
    public static DepartmentPostBean getDepartment(String adminUserid,String departname,String pid) throws Exception {
        if(pid == null || pid.isEmpty()){
            pid = "decision-dep-root";
        }

        List<DepartmentPostBean> departmentTree = getDepartmentsUnderParentDepartment(adminUserid,pid);

        DepartmentPostBean result = null;

        for(DepartmentPostBean dpb : departmentTree){
            if(dpb.getText().equals(departname)){
                result = dpb;
                break;
            }
        }

        return result;
    }
}
