package com.eco.plugin.xx.jbsync.utils;

import com.eco.plugin.xx.jbsync.kit.DepartmentServiceKit;
import com.fr.decision.authority.data.Department;
import com.fr.json.JSONObject;

/**
 * 机构操作类
 */
public class OrgUtils {

    /**
     * 操作机构
     * @param param
     * @return
     */
    public static JSONObject operOrg(JSONObject param) {
        JSONObject result = new JSONObject();
        result.put("code","-1");
        //获取参数
        String orgCode = param.getString("orgCode");
        String orgName = param.getString("orgName");
        String status = param.getString("status");
        String parentCode = param.getString("parentCode");

        DepartmentServiceKit departmentService = DepartmentServiceKit.getInstance();
        Department dept = null;
        try {
             dept = departmentService.getByid(orgCode);
        } catch (Exception e) {
            result.put("msg","获取机构失败!");
            return result;
        }

        //判断操作类型做不同的操作 status 1正常 0停用
        //org已经存在
        if(dept != null && Utils.isNotNullStr(dept.getId())){
            //删除机构
            if("0".equals(status)){
                try {
                    FRDepartmentUtils.deleteDepartment(orgCode);
                } catch (Exception e) {
                    result.put("msg","删除机构失败!");
                    return result;
                }
            }
            else{
                try {
                    updateOrg(orgCode,orgName);
                } catch (Exception e) {
                    result.put("msg","修改机构失败!");
                    return result;
                }
            }

        }else{
            //删除机构
            if("0".equals(status)){
                result.put("code","0");
                result.put("msg","删除成功");
            }
            else{
                try {
                    departmentService.addDepartment(orgCode,parentCode,orgName);
                } catch (Exception e) {
                    result.put("msg","添加机构失败!");
                    return result;
                }

            }
        }

        result.put("code","0");
        result.put("msg","成功");
        return result;
    }

    /**
     * 修改机构
     * @param orgName
     * @param orgid
     * @throws Exception
     */
    private static void updateOrg(String orgid,String orgName) throws Exception {
        FRDepartmentUtils.updateDP(orgid,orgName);
    }
}
